
// SYSLOOP® Serial Protocol © Copyright 2016 EMPYREUM® Information Technologies. All rights reserved.
// This work (ideas, program logic, algorithms, systems, methods, concepts, or layouts) is the intellectual property of EMPYREUM®.

#include "CRC8.h"

void CRC8Put(uint16_t* work, const void* data, uint64_t size) {
	const uint8_t *d = data, *dl = d + size; uint8_t i;
	while(d != dl) {
		(*work) ^= *d++ << 8;
		for(i = 0; i < 8; i++) {
			if(*work & 0x8000) *work ^= (0x1070 << 3);
			(*work) <<= 1;
		}
	}
}

uint8_t CRC8(const void* data, uint64_t size) {
	uint16_t work = 0;
	CRC8Put(&work, data, size);
	return work >> 8;
}

uint8_t CRC8Test(const void* data, uint64_t size) {
	const uint8_t *d = data;
	unsigned crc = 0;
	int i, j;
	for (j = size; j; j--, d++) {
		crc ^= (*d << 8);
		for(i = 8; i; i--) {
			if (crc & 0x8000)
				crc ^= (0x1070 << 3);
			crc <<= 1;
		}
	}
	return (uint8_t)(crc >> 8);
}
