
// SYSLOOP® Serial Protocol © Copyright 2016 EMPYREUM® Information Technologies. All rights reserved.
// This work (ideas, program logic, algorithms, systems, methods, concepts, or layouts) is the intellectual property of EMPYREUM®.

#include "arr.h"
#include "npow2.h"
#include "log.h"
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

void* arrexp(void** buffer, uint64_t* size, uint64_t* capacity, uint64_t space) {
	if((*size + space) > *capacity) {
		uint64_t capacityNew = npow2(*size + space);
		void* bufferNew = realloc(*buffer, capacityNew);
		if(bufferNew == NULL) { logerrno(); return NULL; }
		*buffer = bufferNew;
		*capacity = capacityNew;
	}
	return (char*)*buffer + (*size);
}

bool arrcmp(void** buffer, uint64_t* size, uint64_t* capacity) {
	if(*capacity > *size) {
		void* bufferNew = realloc(*buffer, *size);
		if(bufferNew == NULL && *size) { logerrno(); return true; } // [fixed]
		*buffer = bufferNew;
		*capacity = *size;
	}
	return false;
}

